from math import *

# AE in m
AE = 149.6 * 1000000000.0

# Masse der Sonne in kg
Ms = 1.989E30

# Newtonsche Gravitationskonstante
G = 6.6743E-11

#   Aufgabe 1   

# Absolute Helligkeit von Apophis in mag
HA = 9.5

# Erddistanz von Apophis in AE
deltaA = 0.1008

# Sonnendistanz von Apophis in AE
rA = 1.0645

# Scheinbare Helligkeit von Apophis
mA = HA + 5.0 * log10(deltaA * rA)

print ("Lösung Aufgabe 1:\n")
print ("-----------------\n")
print ("Die scheinbare Helligkeit von Apophis beträgt %2.2f mag.\n\n" %(mA))

#   Aufgabe 2   

# Dichte von Apophis in kg/m³
rhoA = 2.4

# Durchmesser von Apophis in m
dA = 270.0

VA = (4.0 / 3.) * pi * (dA / 2.0)**3
MA = VA * rhoA

print ("Lösung Aufgabe 2:\n")
print ("-----------------\n")
print ("Die Masse von Apophis beträgt %E kg.\n\n" %(MA))

#   Aufgabe 3   

# a in AE
a = 0.9224

e = 0.1912

b = a * sqrt(1.0 - e**2)

q = a * (1.0 - e)

Q = a * (1.0 + e)

print ("Lösung Aufgabe 3:\n")
print ("-----------------\n")
print ("Die Länge der kleinen Halbachse der Bahn von Apophis beträgt %4.4f AE.\n" %(b))
print ("Die Periheldistanz von Apophis beträgt %4.4f AE.\n" %(q))
print ("Die Apheldistanz von Apophis beträgt   %4.4f AE.\n\n" %(Q))

#   Aufgabe 4   

# a in m
a = a * AE

# b in m
b = b * AE

#B in m
B = 6500 * 1000.0

bm = b + B

def VQ(a, b):
    return (b / (a + sqrt(a**2 - b**2))) * sqrt(G * Ms / a)

dv = VQ(a, b) - VQ(a, bm)

Ekin = 0.5 * MA * dv**2

print ("Lösung Aufgabe 4:\n")
print ("-----------------\n")
print ("Die Geschwindigkeitsänderung dv beträgt %4.4f m/s.\n" %(dv))
print ("Dies Entspricht einer Energie von %4.4f MJ.\n" %(Ekin / 1e6))
